<?php
  global $SITEURL;
  require_once(GSPLUGINPATH.'i18n_search/viewer.class.php');
  $i18n = &$params; // alias for i18n parsing
  $slug = array_key_exists('slug',$params) ? $params['slug'] : return_page_slug();
  $showTags = array_key_exists('showTags',$params) ? $params['showTags'] : true;
  $minTagSizePercent = array_key_exists('minTagSize',$params) ? (int) $params['minTagSize'] : 100;
  $maxTagSizePercent = array_key_exists('maxTagSize',$params) ? (int) $params['maxTagSize'] : 250;
  $goText = @$i18n['GO'];
  $is_ajax = !isset($params['ajax']) || $params['ajax'];
  $url = find_url($slug,null);
  $method = strpos($url,'?') !== false ? 'POST' : 'GET'; // with GET the parameters are not submitted!
?>
<form action="<?php echo $url; ?>" method="<?php echo $method; ?>" class="search">
<?php if ($showTags && $minTagSizePercent && $maxTagSizePercent && $minTagSizePercent > 0 && $minTagSizePercent <= $maxTagSizePercent) { ?>
  <div class="tags" style="display:none">
  	<?php I18nSearchViewer::displayTagsImpl($minTagSizePercent,$maxTagSizePercent); ?>
  </div>
  <input type="hidden" name="tags" value="<?php echo htmlspecialchars(@$_REQUEST['tags']); ?>"/>
  <script type="text/javascript">
    $(function() {
      $('.tags').show();
      $('.tags .tag').click(function(e) {
        $(e.target).toggleClass('selected');
        var tags = ''
        $('.tags .tag.selected').each(function() { tags += ' '+$(this).text(); });
        $('[name=tags]').val(tags);
        <?php if ($is_ajax) { ?>
        if (tags == '') {
          $('.tags .tag').removeClass('unavailable');
        } else {
          $.ajax({
            url:'<?php echo $SITEURL; ?>plugins/i18n_search/ajax/tags4tags.php', 
            data:{tags:tags},
            success:function(data,textStatus,jqXHR) {
              $('.tags .tag').each(function() { 
                if (data[$(this).text()] > 0) $(this).removeClass('unavailable'); else $(this).addClass('unavailable')
              });
            },
            error:function(jqXHR,textStatus,errorThrown) {
              $('.tags .tag').removeClass('unavailable');
            }
          });
        }
        <?php } ?>
      });
      var tags = $('[name=tags]').val().split(' ');
      $('.tags .tag').each(function() { if ($.inArray($(this).text(),tags) >= 0) $(this).addClass('selected'); });
    })
  </script>
<?php } ?>
  <input type="text" name="words" value="<?php echo htmlspecialchars(@$_REQUEST['words']); ?>"/>
  <input type="submit" name="search" value="<?php echo @$goText; ?>" />
  <?php if ($is_ajax) { ?>
  <script type="text/javascript" src="<?php echo $SITEURL; ?>plugins/i18n_search/js/jquery.autocomplete.min.js"></script>
  <script type="text/javascript">
    $(function () {
      // add css file
      $('head').append('<link rel="stylesheet" type="text/css" href="<?php echo $SITEURL; ?>plugins/i18n_search/css/jquery.autocomplete.css"></link>');
      $('form.search input[name=words]').autocomplete(
        '<?php echo $SITEURL; ?>plugins/i18n_search/ajax/suggest.php', { 
        minChars: 1,
        max: 50,
        scroll: true,
        multiple: true,
        multipleSeparator: ' '
      });
    });
  </script>
  <?php } ?>
</form>
