<?php
if (!function_exists('i18n_search_display_with_component')) {
  function i18n_search_display_with_component($item, $component) {
    eval("?>" . $component . "<?php ");
  }
}

  $i18n = &$params; // alias for i18n parsing
  $is_i18n = function_exists('return_i18n_default_language');
  if ($is_i18n && array_key_exists('i18n',$params) && !$params['i18n']) $is_i18n = false;
  $tags = array_key_exists('tags',$params) ? $params['tags'] : (isset($_REQUEST['tags']) ? trim($_REQUEST['tags']) : null);
  $words = array_key_exists('words',$params) ? $params['words'] : (isset($_REQUEST['words']) ? trim($_REQUEST['words']) : null);
  if (array_key_exists('addTags',$params)) $tags .= ' '.$params['addTags'];
  if (array_key_exists('addWords',$params)) $words .= ' '.$params['addWords'];
  $order = array_key_exists('order',$params) ? $params['order'] : null;
  $lang = array_key_exists('lang',$params) ? $params['lang'] : null;
  if (!$tags && !$words && !isset($_REQUEST['tags']) && !isset($_REQUEST['words'])) return;
  $headerText = @$i18n['HEADER'];
  $notFoundText = @$i18n['NOT_FOUND'];
  $showLanguage = $is_i18n && array_key_exists('showLanguage',$params) ? $params['showLanguage'] : $is_i18n;
  $showDate = array_key_exists('showDate',$params) ? $params['showDate'] : true;
  $dateLocale = @$i18n['DATE_LOCALE'];
  $dateFormat = @$i18n['DATE_FORMAT'];
  $numWords = array_key_exists('numWords',$params) ? $params['numWords'] : I18N_NUM_WORDS;
  $max = array_key_exists('max',$params) ? (int) $params['max'] : I18N_MAX_RESULTS; 
  $showPaging = array_key_exists('showPaging',$params) ? $params['showPaging'] : true;
  $componentName = array_key_exists('component',$params) ? $params['component'] : null;

  $pageNum = isset($_REQUEST['page']) ? @((int) $_REQUEST['page']) - 1 : 0;
  $first = $pageNum * $max;
  $r = return_i18n_search_results($tags, $words, $first === null ? 0 : $first, $max, $order, $lang);
  $results = $r['results'];
  if (trim($headerText) != '') {
?>
  <h2 class="search-header"><?php echo $headerText; ?></h2>
<?php
  }
  if (count($results) <= 0) {
?>
<p class="search-no-results"><?php echo htmlspecialchars($notFoundText); ?></p>
<?php
  } else {
    $numpages = 1 + (int)(($r['totalCount']-1) / $max);
    $oldLocale = setlocale(LC_TIME,'0');
    if ($dateLocale) setlocale(LC_TIME, preg_split('/\s*,\s*/', $dateLocale));
    if ($componentName) {
      if (function_exists('return_i18n_component')) {
        $component = return_i18n_component($componentName);
      } else {
        if (file_exists(GSDATAOTHERPATH.'components.xml')) {
          $data = getXML(GSDATAOTHERPATH.'components.xml');
          if (count($data->item) != 0) foreach ($data->item as $item) {
            if ($componentName == $item->slug) { 
              $component = stripslashes(htmlspecialchars_decode($item->value, ENT_QUOTES));
              break;
            }
          }
        }
      }
    }
?>
<ul class="search-results">
<?php
    foreach ($results as $item) {
?>
  <li class="search-entry">
<?php
      if (@$component) {
        i18n_search_display_with_component($item, $component);
      } else {
        global $filters;
        $done = false;
        foreach ($filters as $filter)  {
          if ($filter['filter'] == I18N_FILTER_DISPLAY_ITEM) {
            if (call_user_func_array($filter['function'], array($item, $showLanguage, $showDate, $dateFormat, $numWords))) {
              $done = true; 
              break; 
            }
          }
        }
        if (!$done) {
          $link = !$is_i18n && @$item->simplelink ? $item->simplelink : $item->link;
?>
    <h3 class="search-entry-title">
<?php     if ($showLanguage) { ?>
      <span class="search-entry-language"><?php echo htmlspecialchars($item->language, ENT_NOQUOTES); ?></span>
<?php     } ?>
<?php     if ($link) { ?>
      <a href="<?php echo htmlspecialchars($link); ?>">
<?php     } ?>
        <?php echo htmlspecialchars($item->title, ENT_NOQUOTES); ?>
<?php     if ($link) { ?>
      </a>
<?php     } ?>
    </h3>
<?php     if ($showDate) { ?>
    <div class="search-entry-date"><?php echo strftime($dateFormat, $item->pubDate); ?></div>
<?php     } ?>
    <div class="search-entry-excerpt"><?php echo $item->getExcerpt($item->content,$numWords); ?></div>
<?php   
        } 
      }      
?>
  </li>
<?php
    }
    if ($dateLocale) setLocale(LC_TIME, $oldLocale);
?>
</ul>
<?php
    if ($showPaging && $numpages > 1) {
      // determine link
      $link = function_exists('get_i18n_page_url') ? get_i18n_page_url(true) : get_page_url(true);
      $link .= (strpos($link,'?') !== false ? '&' : '?');
      $link .= 'tags='.urlencode(@$_REQUEST['tags']).'&words='.urlencode(@$_REQUEST['words']);
      $link .= '&search='.urlencode(@$_REQUEST['search']);
      if (defined('PAGIFY_SEPARATOR')) {
        preg_match('/^([^\?]*[^\?\/])(\/?(\?.*)?)$/', $link, $match);
        $link = $match[1].PAGIFY_SEPARATOR.'%PAGE%'.@$match[2];
      } else {
        $link .= '&page=%PAGE%';
      }
      if (function_exists('return_pagify_navigation')) {
        $pagingHtml = return_pagify_navigation($numpages, $pageNum, $link);
      } else {
        $link = htmlspecialchars($link);
        $pagingHtml = '<div class="paging">';
        if (@$i18n['FIRST_TEXT'] && $pageNum > 0) {
          $pagingHtml .= '<span class="first"><a href="'.str_replace('%PAGE%',1,$link).'" title="'.htmlspecialchars(@$i18n['FIRST_TITLE']).'">'.htmlspecialchars(@$i18n['FIRST_TEXT']).'&nbsp;</a></span>';
        }
        if (@$i18n['PREV_TEXT'] && $pageNum > 0) {
          $pagingHtml .= '<span class="previous"><a href="'.str_replace('%PAGE%',$pageNum,$link).'" title="'.htmlspecialchars(@$i18n['PREV_TITLE']).'">'.htmlspecialchars(@$i18n['PREV_TEXT']).'&nbsp;</a></span>';
        }
        for ($i=0; $i<$numpages; $i++) {
          if ($i == $pageNum) {
            $pagingHtml .= ' <span class="current">'.($i+1).'</span>';
          } else {
            $pagingHtml .= ' <span><a href="'.str_replace('%PAGE%',$i+1,$link).'">'.($i+1).'</a></span>';
          }
        }
        if (@$i18n['NEXT_TEXT'] && $pageNum < $numpages-1) {
          $pagingHtml .= ' <span class="next"><a href="'.str_replace('%PAGE%',$pageNum+2,$link).'" title="'.htmlspecialchars(@$i18n['NEXT_TITLE']).'">&nbsp;'.htmlspecialchars(@$i18n['NEXT_TEXT']).'</a></span>';
        }
        if (@$i18n['LAST_TEXT'] && $pageNum < $numpages-1) {
          $pagingHtml .= ' <span class="next"><a href="'.str_replace('%PAGE%',$numpages,$link).'" title="'.htmlspecialchars(@$i18n['LAST_TITLE']).'">&nbsp;'.htmlspecialchars(@$i18n['LAST_TEXT']).'</a></span>';
        }
        $pagingHtml .= '</div>';
      }
      echo "\n" . $pagingHtml;
    }
  }

